/*
 * EVA_Prinzip.c
 *
 * Created: 22.12.2014 19:55:35
 *
 */ 

/*
'KS0108 TG12864B
' Pin LCD - Pin Atmega
' 1  Vss          9V oder 5V
' 2  VDD          5V?
' 3  V0           GND
' 4  D/I
' 5  R/W          Port C0
' 6  E            Enable also 5V?
' 7  DB0          Port A0
' 8  DB1          Port A1
' 9  DB2          Port A2
'10  DB3          Port A3
'11  DB4          Port A4
'12  DB5          Port A5
'13  DB6          Port A6
'14  DB7          Port A7
'15  CS1
'16  CS2
'17  RST          Reset?
'18  VEE          Kontrast?
'19  K            LED - also GND
'20  A            LED + also 5V
*/

#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "ks0108.h"
#include "ps2kbd.h"
#include "arial_8.h"
#include "corsiva_12.h"
#include "arial_bold_14.h"
#include "bitmap.h"
#include "keycodes.h"
#include <string.h>

#ifndef F_CPU
#define F_CPU 16000000UL
#endif

#define SWITCH_PORT PORTC
#define SWITCH_DDR DDRC
#define SWITCH_PIN_ENABLE PC0
#define SWITCH_PIN_DISABLE PC1

#define ENABLE  0xf4
#define DISABLE 0xf5


int main(void)
{	
	int i = 0;
	uint8_t data = 0;
	uint8_t Auswertung=0;
	uint8_t data_anzeige_y = 0;
	uint8_t data_anzeige_x = 0;
	uint8_t data_anzeige_v = 0;
	uint8_t data_anzeige_n = 0;
	uint8_t data_anzeige_b = 0;
	uint8_t data_anzeige_c = 0;
	char Outputdata[11];
	char Stationname_Y[11];
	char Stationname_X[11];
	char Stationname_V[11];
	char Stationname_N[11];
	char Stationname_B[11];
	char Stationname_C[11];
	int counter_left=0;
	int counter_right=0;
	
	ks0108Init(0);	//Initialisierung des LCD
	kbd_init();		//Initialisierung des PS/2 Keyboards

	SWITCH_DDR &= ~(1<<SWITCH_PIN_ENABLE);		//Deklaration als Input / Eingang
	SWITCH_DDR &= ~(1<<SWITCH_PIN_DISABLE);		//Deklaration als Input / Eingang

	sei();	//Freigeben des Interrupts
	
	ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
	ks0108GotoXY(20, 20);
	ks0108Puts_P(PSTR("Fahrt von Vechta"));
	ks0108GotoXY(27, 30);
	ks0108Puts_P(PSTR("nach Oldenburg"));
	
	do 
	{
		if(! (PINC & (1<<SWITCH_PIN_ENABLE) ) )			//Tasterabfrage zum Enablen der Tastatur
		{
			kbd_send(ENABLE);
		}
	
		if(! (PINC & (1<<SWITCH_PIN_DISABLE) ) )		//Tasterabfrage zum Disablen der Tastatur
		{
			kbd_send(DISABLE);
		}
		
		while (i < 10)
		{
			data=kbd_getchar();
			if (data)
			{
				if (data == ENTER)
				{
					Outputdata[i] = 0;
					break;
				}
				Outputdata[i] = data;
				i++;
			}
		}
		 
		Auswertung=Outputdata[0];

		switch(Auswertung)
		{
			case CTRL_Q:
				
				/******************** Weg von Oldenburg nach Vechta ****************************/
						
				if((Auswertung=CTRL_Q) && (counter_right==0))
				{
					ks0108ClearScreen();
					/*Anzeige 1*/
			
					//Zeichnen des ueren Rechtecks
					ks0108DrawRect(0, 0, 127, 63, BLACK);
					//Zeichnen der mittleren Linie
					ks0108DrawLine(0, 34, 127, 34, BLACK);
			
					//Zeichnen der Beschriftungen im oberen Feld "Bremen"
					ks0108DrawCircle(6, 10, 2, BLACK);
					ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
					ks0108GotoXY(13, 5);
					//ks0108Puts_P(PSTR("Bremen"));
					ks0108Puts(Stationname_Y);
					ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
					ks0108GotoXY(31, 20);
					ks0108Puts_P(PSTR("250 km/h"));
					ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
			
					//Zeichnen der Beschriftungen im unteren Feld "Bremen"
					ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
					ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
					ks0108GotoXY(16, 40);
					ks0108Puts_P(PSTR("Diepholz"));
					ks0108DrawRect(5, 55, 4, 4, BLACK);
					ks0108FillRect(5, 55, 4, 4, BLACK);
					ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
					ks0108GotoXY(16, 53);
					ks0108Puts_P(PSTR("Vechta"));
					Outputdata[0]=0;
					counter_right++;
					i=0;
				}
			
				else
				{
					if((Auswertung=CTRL_Q) && (counter_right==1))	
					{
						ks0108ClearScreen();
								
						/*Anzeige 2*/
							
						//Zeichnen des ueren Rechtecks
						ks0108DrawRect(0, 0, 127, 63, BLACK);
						//Zeichnen der mittleren Linie
						ks0108DrawLine(0, 34, 127, 34, BLACK);
							
						//Zeichnen der Beschriftungen im oberen Feld "Diepholz"
						ks0108DrawCircle(6, 10, 2, BLACK);
						ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
						ks0108GotoXY(13, 5);
						//ks0108Puts_P(PSTR("Diepholz"));
						ks0108Puts(Stationname_X);
						ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
						ks0108GotoXY(31, 20);
						ks0108Puts_P(PSTR("160 km/h"));
						ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
								
						//Zeichnen der Beschriftungen im unteren Feld "Diepholz"
						ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
						ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
						ks0108GotoXY(16, 40);
						ks0108Puts_P(PSTR("Vechta"));
						Outputdata[0]=0;
						counter_right++;
						i=0;
					}
					else
					{
						if((Auswertung = CTRL_Q) && (counter_right==2))		
						{	
						ks0108ClearScreen();
								
						/*Anzeige 3*/
						
						//Zeichnen des ueren Rechtecks
						ks0108DrawRect(0, 0, 127, 63, BLACK);
						//Zeichnen der mittleren Linie
						ks0108DrawLine(0, 34, 127, 34, BLACK);
						
						//Zeichnen der Beschriftungen im oberen Feld "Vechta"
						ks0108DrawCircle(6, 10, 2, BLACK);
						ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
						ks0108GotoXY(13, 5);
						//ks0108Puts_P(PSTR("Vechta"));
						ks0108Puts(Stationname_C);
						ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
						ks0108GotoXY(31, 20);
						ks0108Puts_P(PSTR("120 km/h"));
						ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
						counter_right=0;
						Outputdata[0]=0;
						i=0;
						}
					}
				}
			break;
			
			case CTRL_W:
			
				/******************** Weg von Vechta nach Oldenburg ****************************/
					
				if((Auswertung = CTRL_W) && (counter_left==0))		
				{
					ks0108ClearScreen();
					
					/*Anzeige 1*/
							
					//Zeichnen des ueren Rechtecks
					ks0108DrawRect(0, 0, 127, 63, BLACK);
					//Zeichnen der mittleren Linie
					ks0108DrawLine(0, 34, 127, 34, BLACK);
							
					//Zeichnen der Beschriftungen im oberen Feld "Diepholz"
					ks0108DrawCircle(6, 10, 2, BLACK);
					ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
					ks0108GotoXY(13, 5);
					//ks0108Puts_P(PSTR("Diepholz"));
					ks0108Puts(Stationname_V);
					ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
					ks0108GotoXY(31, 20);
					ks0108Puts_P(PSTR("120 km/h"));
					ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
							
					//Zeichnen der Beschriftungen im unteren Feld "Diepholz"
					ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
					ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
					ks0108GotoXY(16, 40);
					ks0108Puts_P(PSTR("Bremen"));
					ks0108DrawRect(5, 55, 4, 4, BLACK);
					ks0108FillRect(5, 55, 4, 4, BLACK);
					ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
					ks0108GotoXY(16, 53);
					ks0108Puts_P(PSTR("Oldenburg"));
					counter_left++;
					Outputdata[0]=0;
					i=0;
				}
				
				else
				{
					if((Auswertung = CTRL_W) && (counter_left==1))	
					{		
						ks0108ClearScreen();
							
						/*Anzeige 2*/
							
						//Zeichnen des ueren Rechtecks
						ks0108DrawRect(0, 0, 127, 63, BLACK);
						//Zeichnen der mittleren Linie
						ks0108DrawLine(0, 34, 127, 34, BLACK);
							
						//Zeichnen der Beschriftungen im oberen Feld "Bremen"
						ks0108DrawCircle(6, 10, 2, BLACK);
						ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
						ks0108GotoXY(13, 5);
						//ks0108Puts_P(PSTR("Bremen"));
						ks0108Puts(Stationname_B);
						ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
						ks0108GotoXY(31, 20);
						ks0108Puts_P(PSTR("160 km/h"));
						ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
					
						//Zeichnen der Beschriftungen im unteren Feld "Bremen"
						ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
						ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
						ks0108GotoXY(16, 40);
						ks0108Puts_P(PSTR("Oldenburg"));
						counter_left++;
						Outputdata[0]=0;
						i=0;
					}
					
					else
					{
						if((Auswertung = CTRL_W) && (counter_left==2))				
						{			
							ks0108ClearScreen();
							
							/*Anzeige 3*/
							
							//Zeichnen des ueren Rechtecks
							ks0108DrawRect(0, 0, 127, 63, BLACK);
							//Zeichnen der mittleren Linie
							ks0108DrawLine(0, 34, 127, 34, BLACK);
							
							//Zeichnen der Beschriftungen im oberen Feld "Oldenburg"
							ks0108DrawCircle(6, 10, 2, BLACK);
							ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
							ks0108GotoXY(13, 5);
							//ks0108Puts_P(PSTR("Oldenburg"));
							ks0108Puts(Stationname_N);
							ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
							ks0108GotoXY(31, 20);
							ks0108Puts_P(PSTR("250 km/h"));
							ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
							counter_left=0;
							Outputdata[0]=0;
							i=0;
						}
					}
				}
			break;	
			
			case CTRL_Y:
			
					ks0108ClearScreen();
					/*Anzeige 1*/
						
					//Zeichnen des ueren Rechtecks
					ks0108DrawRect(0, 0, 127, 63, BLACK);
					//Zeichnen der mittleren Linie
					ks0108DrawLine(0, 34, 127, 34, BLACK);
						
					//Zeichnen der Beschriftungen im oberen Feld "Bremen"
					ks0108DrawCircle(6, 10, 2, BLACK);
					ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
					ks0108GotoXY(13, 5);
					//ks0108Puts_P(PSTR("Bremen"));
					ks0108Puts(Stationname_Y);
					ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
					ks0108GotoXY(31, 20);
					ks0108Puts_P(PSTR("250 km/h"));
					ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
						
					//Zeichnen der Beschriftungen im unteren Feld "Bremen"
					ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
					ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
					ks0108GotoXY(16, 40);
					ks0108Puts_P(PSTR("Diepholz"));
					ks0108DrawRect(5, 55, 4, 4, BLACK);
					ks0108FillRect(5, 55, 4, 4, BLACK);
					ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
					ks0108GotoXY(16, 53);
					ks0108Puts_P(PSTR("Vechta"));
					Outputdata[0]=0;
					i=0;
			break;		
			
			case ALT_Y:

				Stationname_Y[10] ='\0';
				while (i < 10)
				{
					
					data_anzeige_y=kbd_getchar();
					if (data_anzeige_y)
					{
						if (data_anzeige_y == ENTER)
						{
							Stationname_Y[i] = 0;
							break;
						}
						Stationname_Y[i] = data_anzeige_y;
						i++;
					}
				}
			 
				ks0108ClearScreen();
				/*Anzeige 1*/
				
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
			 				
				//Zeichnen der Beschriftungen im oberen Feld "Bremen"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Bremen"));
				ks0108Puts(Stationname_Y);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("250 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
						
				//Zeichnen der Beschriftungen im unteren Feld "Bremen"
				ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 40);
				ks0108Puts_P(PSTR("Diepholz"));
				ks0108DrawRect(5, 55, 4, 4, BLACK);
				ks0108FillRect(5, 55, 4, 4, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 53);
				ks0108Puts_P(PSTR("Vechta"));
				i=0;
				Outputdata[0]=0;
			break;
				
			case CTRL_X:
			
				ks0108ClearScreen();
			
				/*Anzeige 2*/
			
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
			
				//Zeichnen der Beschriftungen im oberen Feld "Diepholz"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Diepholz"));
				ks0108Puts(Stationname_X);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("160 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
			
				//Zeichnen der Beschriftungen im unteren Feld "Diepholz"
				ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 40);
				ks0108Puts_P(PSTR("Vechta"));
				Outputdata[0]=0;
				i=0;
			break;
			
			case ALT_X:
				
				Stationname_X[10] ='\0';	
				while (i < 10)
				{
					data_anzeige_x=kbd_getchar();
					if (data_anzeige_x)
					{
						if (data_anzeige_x == ENTER)
						{
							Stationname_X[i] = 0;
							break;
						}
						Stationname_X[i] = data_anzeige_x;
						i++;
					}
				}		
			
				ks0108ClearScreen();
							
				/*Anzeige 2*/
				
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
					
				//Zeichnen der Beschriftungen im oberen Feld "Diepholz"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Diepholz"));
				ks0108Puts(Stationname_X);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("160 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
				
				//Zeichnen der Beschriftungen im unteren Feld "Diepholz"
				ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 40);
				ks0108Puts_P(PSTR("Vechta"));
				Outputdata[0]=0;
				i=0;
			break;
					
			case CTRL_C:

				ks0108ClearScreen();
			
				/*Anzeige 3*/
			
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
			
				//Zeichnen der Beschriftungen im oberen Feld "Vechta"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Vechta"));
				ks0108Puts(Stationname_C);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("120 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
				Outputdata[0]=0;
				i=0;
			break;
				
			case ALT_C:
			
				Stationname_C[10] ='\0';
				while (i < 10)
				{
					
					data_anzeige_c=kbd_getchar();
					if (data_anzeige_c)
					{
						if (data_anzeige_c == ENTER)
						{
							Stationname_C[i] = 0;
							break;
						}
						Stationname_C[i] = data_anzeige_c;
						i++;
					}
				}						
							
				ks0108ClearScreen();
					
				/*Anzeige 3*/
				
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
					
				//Zeichnen der Beschriftungen im oberen Feld "Vechta"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Vechta"));
				ks0108Puts(Stationname_C);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("120 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
				Outputdata[0]=0;
				i=0;
			break;			
			
							
			
				
				/////******************** Weg von Vechta nach Oldenburg ****************************/ 
			
			case CTRL_V:
			
				ks0108ClearScreen();
							
				/*Anzeige 1*/
						
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
						
				//Zeichnen der Beschriftungen im oberen Feld "Diepholz"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Diepholz"));
				ks0108Puts(Stationname_V);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("120 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
							
				//Zeichnen der Beschriftungen im unteren Feld "Diepholz"
				ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 40);
				ks0108Puts_P(PSTR("Bremen"));
				//ks0108Puts(Stationname_B);
				ks0108DrawRect(5, 55, 4, 4, BLACK);
				ks0108FillRect(5, 55, 4, 4, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 53);
				ks0108Puts_P(PSTR("Oldenburg"));
				//ks0108Puts(Stationname_N);
				Outputdata[0]=0;
				i=0;
			break;
		
			case ALT_V:
				
				Stationname_V[10] ='\0';		
				while (i < 10)
				{
					data_anzeige_v=kbd_getchar();
					if (data_anzeige_v)
					{
						if (data_anzeige_v == ENTER)
						{
							Stationname_V[i] = 0;
							break;
						}
						Stationname_V[i] = data_anzeige_v;
						i++;
					}
				}
						
				ks0108ClearScreen();
			
				/*Anzeige 1*/
					
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
					
				//Zeichnen der Beschriftungen im oberen Feld "Diepholz"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Diepholz"));
				ks0108Puts(Stationname_V);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("120 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
				
				//Zeichnen der Beschriftungen im unteren Feld "Diepholz"
				ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 40);
				ks0108Puts_P(PSTR("Bremen"));
				ks0108DrawRect(5, 55, 4, 4, BLACK);
				ks0108FillRect(5, 55, 4, 4, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 53);
				ks0108Puts_P(PSTR("Oldenburg"));
				Outputdata[0]=0;
				i=0;
			break;

				
			case CTRL_B:
		
				ks0108ClearScreen();
		
				/*Anzeige 2*/
		
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
		
				//Zeichnen der Beschriftungen im oberen Feld "Bremen"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Bremen"));
				ks0108Puts(Stationname_B);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("160 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
		
				//Zeichnen der Beschriftungen im unteren Feld "Bremen"
				ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 40);
				ks0108Puts_P(PSTR("Oldenburg"));
				Outputdata[0]=0;
				i=0;
			break;
				
			case ALT_B:
			
				Stationname_B[10] ='\0';
				while (i < 10)
				{
					
					data_anzeige_b=kbd_getchar();
					if (data_anzeige_b)
					{
						if (data_anzeige_b == ENTER)
						{
							Stationname_B[i] = 0;
							break;
						}
						Stationname_B[i] = data_anzeige_b;
						i++;
					}
				}	
				
				ks0108ClearScreen();
						
				/*Anzeige 2*/
					
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
						
				//Zeichnen der Beschriftungen im oberen Feld "Bremen"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Bremen"));
				ks0108Puts(Stationname_B);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("160 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
				
				//Zeichnen der Beschriftungen im unteren Feld "Bremen"
				ks0108DrawRoundRect(5, 41, 4, 4, 1, BLACK);
				ks0108SelectFont(Arial_8, ks0108ReadFontData, BLACK);
				ks0108GotoXY(16, 40);
				ks0108Puts_P(PSTR("Oldenburg"));
				Outputdata[0]=0;
				i=0;
			break;	
					
			case CTRL_N:

				ks0108ClearScreen();
		
				/*Anzeige 3*/
		
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
		
				//Zeichnen der Beschriftungen im oberen Feld "Oldenburg"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Oldenburg"));
				ks0108Puts(Stationname_N);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("250 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
				Outputdata[0]=0;
				i=0;
			break;
				
			case ALT_N:
			
				Stationname_N[10] ='\0';
				while (i < 10)
				{
					data_anzeige_n=kbd_getchar();
					if (data_anzeige_n)
					{
						if (data_anzeige_n == ENTER)
						{
							Stationname_N[i] = 0;
							break;
						}
						Stationname_N[i] = data_anzeige_n;
						i++;
					}
				}
				
				ks0108ClearScreen();
				
				/*Anzeige 3*/
				
				//Zeichnen des ueren Rechtecks
				ks0108DrawRect(0, 0, 127, 63, BLACK);
				//Zeichnen der mittleren Linie
				ks0108DrawLine(0, 34, 127, 34, BLACK);
				
				//Zeichnen der Beschriftungen im oberen Feld "Oldenburg"
				ks0108DrawCircle(6, 10, 2, BLACK);
				ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
				ks0108GotoXY(13, 5);
				//ks0108Puts_P(PSTR("Oldenburg"));
				ks0108Puts(Stationname_N);
				ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
				ks0108GotoXY(31, 20);
				ks0108Puts_P(PSTR("250 km/h"));
				ks0108DrawBitmap(logo_fhwt_46_32, 80, 1, 46, 32);
				Outputdata[0]=0;
				i=0;
			break;

			default:
			break;
		}
		
	} while (1);
}

	//sei();
	//while(1)
	//{
	//ks0108ClearScreen();
	//while (i < 9)
	//{
	//
	//data=kbd_getchar();
	//if (data)
	//{
	//if (data == ENTER)
	//{
	//Outputdata[i] = 0;
	//break;
	//}
	//Outputdata[i] = data;
	//i++;
	//}
	//}
	//
	//Auswertung=Outputdata[1];
	//
	//ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
	//ks0108GotoXY(15,10);
	//ks0108PutChar(Auswertung);
	//Outputdata[0]=0;
	//Outputdata[1]=0;
	//i=0;
	//}
	//while(1)
	//{
	//for(int i=0;i<5;i++)
	//{
	//data=kbd_getchar();
	//Outputdata[i]=data;
	//}
	//
	//ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
	//ks0108GotoXY(15,10);
	//ks0108Puts(Outputdata);
	//}

	//while (1)
	//{
	//for(int i=0;i<5;i++)
	//{
	//while ( kbd_getchar() == 0)
	//{
	//}
	//while (kbd_getchar() != 0)
	//{
	//data = kbd_getchar();
	//}
	//
	//}
	//Outputdata=data;
	//ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
	//ks0108GotoXY(15,10);
	//ks0108Puts(Outputdata);
	//}
	//
	//ks0108ClearScreen();
	//
	
	
					//ks0108SelectFont(Corsiva_12, ks0108ReadFontData, BLACK);
					//ks0108GotoXY(20, 20);
					//ks0108Puts_P(PSTR("Fahrt von Vechta"));
					//ks0108GotoXY(27, 30);
					//ks0108Puts_P(PSTR("nach Oldenburg"));