#ifndef __KEYCODES_H__
#define __KEYCODES_H__

// Funktionstasten (Teilweise im ASCII enthalten)
#define CTRL_
#define NOT_USED	0x00
#define NUL			0x00	// ASCII [NULL]
#define CTRL_A		0x01	// ASCII [START OF HEADING]
#define CTRL_B		0x02	// ASCII [START OF TEXT]
#define CTRL_C		0x03	// ASCII [END OF TEXT]
#define CTRL_D		0x04	// ASCII [END OF TRANSMISSION]
#define CTRL_E		0x05	// ASCII [ENQUIRIY]
#define CTRL_F		0x06	// ASCII [ACKNOWLEGE]
#define CTRL_G		0x07	// ASCII [BELL]
#define CTRL_H		0x08
#define BS			0x08	// ASCII [BACKSPACE]
#define CTRL_I		0x09
#define TAB			0x09	// ASCII [HORIZONTAL TAB]
#define CTRL_J		0x0a	// ASCII [LINE FEED]
#define CTRL_K		0x0b	// ASCII [VERTICAL TAB]
#define CTRL_L		0x0c	// ASCII [FORM FEED]
#define CTRL_M		0x0d
#define ENTER		0x0d	// ASCII [CARRIAGE RETURN]
#define CTRL_N		0x0e	// ASCII [SHIFT OUT]
#define CTRL_O		0x0f	// ASCII [SHIFT IN]
#define CTRL_P		0x10	// ASCII [DATA LINK ESCAPE]
#define CTRL_Q		0x11	// ASCII [DEVICE CONTROL 1]
#define CTRL_R		0x12	// ASCII [DEVICE CONTROL 2]
#define CTRL_S		0x13	// ASCII [DEVICE CONTROL 3]
#define CTRL_T		0x14	// ASCII [DEVICE CONTROL 4]
#define CTRL_U		0x15	// ASCII [NEGATIVE ACKNOWLEDGE]
#define CTRL_V		0x16	// ASCII [SYNCHRONOUS IDLE]
#define CTRL_W		0x17	// ASCII [END OF TRANSMISSION BLOCK]
#define CTRL_X		0x18	// ASCII [CANCEL]
#define CTRL_Y		0x19	// ASCII [END OF MEDIUM]
#define CTRL_Z		0x1a
#define INS			0x1a	// ASCII [SUBSITUTE]
#define ESC			0x1b	// ASCII [ESCAPE]
//					0x1c	// ASCII [FILE SEPARATOR]
//					0x1d	// ASCII [GROUP SEPARATOR]
//					0x1e	// ASCII [RECORD SEPARATOR]
//					0x1f	// ASCII [UNIT SEPARATOR]
#define SPACE		0x20	// ASCII [SPACE]
//					0x21	// ASCII !
//					...		// ASCII weitere Zeichen...
//					0x7e	// ASCII ~
#define DEL			0x7f	// ASCII [DEL]

// Nicht durch ASCII belegte Zeichen werden wie folgt definiert:

// ALT + Buchstabe
//					0x80	//			0x80
#define ALT_A		0x81
#define ALT_B		0x82
#define ALT_C		0x83
#define ALT_D		0x84
#define ALT_E		0x85
#define ALT_F		0x86
#define ALT_G		0x87
#define ALT_H		0x88
#define ALT_I		0x89
#define ALT_J		0x8a
#define ALT_K		0x8b
#define ALT_L		0x8c
#define ALT_M		0x8d
#define ALT_N		0x8e
#define ALT_O		0x8f
#define ALT_P		0x90	//			0x90
#define ALT_Q		0x91
#define ALT_R		0x92
#define ALT_S		0x93
#define ALT_T		0x94
#define ALT_U		0x95
#define ALT_V		0x96
#define ALT_W		0x97
#define ALT_X		0x98
#define ALT_Y		0x99
#define ALT_Z		0x9a
//					0x9b
//					0x9c
//					0x9d
//					0x9e
//					0x9f

//  Funktionstasten
#define F1			0xa0	//			0xa0
#define F2			0xa1
#define F3			0xa2
#define F4			0xa3
#define F5			0xa4
#define F6			0xa5
#define F7			0xa6
#define F8			0xa7
#define F9			0xa8
#define F10			0xa9
#define F11			0xaa
#define F12			0xab

#define SHIFT_F1	0xac
#define SHIFT_F2	0xad
#define SHIFT_F3	0xae
#define SHIFT_F4	0xaf
#define SHIFT_F5	0xb0	//			0xb0
#define SHIFT_F6	0xb1
#define SHIFT_F7	0xb2
#define SHIFT_F8	0xb3
#define SHIFT_F9	0xb4
#define SHIFT_F10	0xb5
#define SHIFT_F11	0xb6
#define SHIFT_F12	0xb7

#define ALT_F1		0xb8
#define ALT_F2		0xb9
#define ALT_F3		0xba
#define ALT_F4		0xbb
#define ALT_F5		0xbc
#define ALT_F6		0xbd
#define ALT_F7		0xbe
#define ALT_F8		0xbf
#define ALT_F9		0xc0	//			0xc0
#define ALT_F10		0xc1
#define ALT_F11		0xc2
#define ALT_F12		0xc3

#define CTRL_F1		0xc4
#define CTRL_F2		0xc5
#define CTRL_F3		0xc6
#define CTRL_F4		0xc7
#define CTRL_F5		0xc8
#define CTRL_F6		0xc9
#define CTRL_F7		0xca
#define CTRL_F8		0xcb
#define CTRL_F9		0xcc
#define CTRL_F10	0xcd
#define CTRL_F11	0xce
#define CTRL_F12	0xcf

// Positionstasten
#define UP			0xd0	//			0xd0
#define DOWN		0xd1
#define LEFT		0xd2
#define RIGHT		0xd3
#define PGUP		0xd4
#define PGDN		0xd5
#define HOME		0xd6
#define END			0xd7
//					0xda
//					0xdb
//					0xdc
//					0xdd
//					0xde
//					0xdf

// Sondertasten
#define MENU		0xe0	//			0xe0
#define WIN			0xe1
#define PRINT		0xe2
#define PAUSE		0xe3
//					0xe4
//					0xe5
//					0xe6
//					0xe7
//					0xe8
//					0xe9
//					0xea
//					0xeb
//					0xec
#define POWER		0xed
#define SLEEP		0xee
#define WAKE		0xef

//					0xf0	//			0xf0
//					0xf1
//					0xf2
//					0xf3
//					0xf4
//					0xf5
//					0xf6
//					0xf7
//					0xf8
//					0xf9
//					0xfa
//					0xfb
//					0xfc
//					0xfd
//					0xfe
//					0xff

static const unsigned char lookUpTable[][6] PROGMEM =
{/* Angepasst fr Standard-Tastatur mit deutschen Tastensatz (Pollin.de, Best-Nr: 711 712)
	Nicht im 7-bit-ASCII vorhandene Zeichen sind sind durch NUL ersetzt
	
	 !"#$%&'()*+,-./0123456789:;<=>?
	@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_
	`abcdefghijklmnopqrstuvwxyz{|}~ 	
		
SC,		normal,	SHIFT,		CTRL,		ALT,		ALT_GR		*/
{0x01,	F9,		SHIFT_F9,	CTRL_F9,	ALT_F9,		ALT_F9},	// F9
{0x03,	F5,		SHIFT_F5,	CTRL_F5,	ALT_F5,		ALT_F5},	// F5
{0x04,	F3,		SHIFT_F3,	CTRL_F3,	ALT_F3,		ALT_F3},	// F3
{0x05,	F1,		SHIFT_F1,	CTRL_F1,	ALT_F1,		ALT_F1},	// F1
{0x06,	F2,		SHIFT_F2,	CTRL_F2,	ALT_F2,		ALT_F2},	// F2
{0x07,	F12,	SHIFT_F12,	CTRL_F12,	ALT_F12,	ALT_F12},	// F12
{0x09,	F10,	SHIFT_F10,	CTRL_F10,	ALT_F10,	ALT_F10},	// F10
{0x0a,	F8,		SHIFT_F8,	CTRL_F8,	ALT_F8,		ALT_F8},	// F8
{0x0b,	F6,		SHIFT_F6,	CTRL_F6,	ALT_F6,		ALT_F6},	// F6
{0x0c,	F4,		SHIFT_F4,	CTRL_F4,	ALT_F4,		ALT_F4},	// F4
{0x0d,	TAB,	TAB,		NOT_USED,	NOT_USED,	NOT_USED},	// Tabulator
{0x0e,	'^',	NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// ^ 
{0x11,	NOT_USED,NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// ALT   (wird bergeordnet behandelt)
{0x12,	NOT_USED,NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// SHIFT (wird bergeordnet behandelt)
{0x14,	NOT_USED,NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// STRG  (wird bergeordnet behandelt)
{0x15,	'q',	'Q',		CTRL_Q,		ALT_Q,		'@'},		// q Q
{0x16,	'1',	'!',		NOT_USED,	NOT_USED,	NOT_USED},	// 1 !
{0x1a,	'y',	'Y',		CTRL_Y,		ALT_Y,		NOT_USED},	// y Y
{0x1b,	's',	'S',		CTRL_S,		ALT_S,		NOT_USED},	// s S
{0x1c,	'a',	'A',		CTRL_A,		ALT_A,		NOT_USED},	// a A
{0x1d,	'w',	'W',		CTRL_W,		ALT_W,		NOT_USED},	// w W
{0x1e,	'2',	'"',		NOT_USED,	NOT_USED,	NOT_USED},	// 2 "
{0x1f,	WIN,	WIN,		WIN,		WIN,		WIN},		// Windows-Taste links
{0x21,	'c',	'C',		CTRL_C,		ALT_C,		NOT_USED},	// c C
{0x22,	'x',	'X',		CTRL_X,		ALT_X,		NOT_USED},	// x X
{0x23,	'd',	'D',		CTRL_D,		ALT_D,		NOT_USED},	// d D
{0x24,	'e',	'E',		CTRL_E,		ALT_E,		NOT_USED},	// e E
{0x25,	'4',	'$',		NOT_USED,	NOT_USED,	NOT_USED},	// 4 $
{0x26,	'3',	NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// 3 
{0x27,	WIN,	WIN,		WIN,		WIN,		WIN},		// Windows-Taste rechts
{0x29,	' ',	' ',		SPACE,		SPACE,		SPACE},		// Leerzeichen
{0x2a,	'v',	'V',		CTRL_V,		ALT_V,		NOT_USED},	// v V
{0x2b,	'f',	'F',		CTRL_F,		ALT_F,		NOT_USED},	// f F
{0x2c,	't',	'T',		CTRL_T,		ALT_T,		NOT_USED},	// t T
{0x2d,	'r',	'R',		CTRL_R,		ALT_R,		NOT_USED},	// r R
{0x2e,	'5',	'%',		NOT_USED,	NOT_USED,	NOT_USED},	// 5 %
{0x2f,	MENU,	MENU,		MENU,		MENU,		MENU},		// Men-Taste
{0x31,	'n',	'N',		CTRL_N,		ALT_N,		NOT_USED},	// n N 
{0x32,	'b',	'B',		CTRL_B,		ALT_B,		NOT_USED},	// b B
{0x33,	'h',	'H',		CTRL_H,		ALT_H,		NOT_USED},	// h H
{0x34,	'g',	'G',		CTRL_G,		ALT_G,		NOT_USED},	// g G
{0x35,	'z',	'Z',		CTRL_Z,		ALT_Z,		NOT_USED},	// z Z
{0x36,	'6',	'&',		NOT_USED,	NOT_USED,	NOT_USED},	// 6 &
{0x37,	POWER,	POWER,		POWER,		POWER,		POWER},		// Power
{0x3a,	'm',	'M',		CTRL_M,		ALT_M,		NOT_USED},	// m M
{0x3b,	'j',	'J',		CTRL_J,		ALT_J,		NOT_USED},	// j J
{0x3c,	'u',	'U',		CTRL_U,		ALT_U,		NOT_USED},	// u U
{0x3d,	'7',	'/',		NOT_USED,	NOT_USED,	'{'},		// 7 / {
{0x3e,	'8',	'(',		NOT_USED,	NOT_USED,	'['},		// 8 ( [
{0x3F,	SLEEP,	SLEEP,		SLEEP,		SLEEP,		SLEEP},		// Sleep
{0x41,	',',	';',		NOT_USED,	NOT_USED,	NOT_USED},	// , ;
{0x42,	'k',	'K',		CTRL_K,		ALT_K,		NOT_USED},	// k K
{0x43,	'i',	'I',		CTRL_I,		ALT_I,		NOT_USED},	// i I
{0x44,	'o',	'O',		CTRL_O,		ALT_O,		NOT_USED},	// o O
{0x45,	'0',	'=',		NOT_USED,	NOT_USED,	'}'},		// 0 = } 
{0x46,	'9',	')',		NOT_USED,	NOT_USED,	']'},		// 9 ) ]
{0x49,	'.',	':',		NOT_USED,	NOT_USED,	NOT_USED},	// . :
{0x4a,	'-',	'_',		NOT_USED,	NOT_USED,	NOT_USED},	// - _
{0x4b,	'l',	'L',		CTRL_L,		ALT_L,		NOT_USED},	// l L
{0x4c,	NUL,	NUL,		NOT_USED,	NOT_USED,	NOT_USED},	//  
{0x4d,	'p',	'P',		CTRL_P,		ALT_P,		NOT_USED},	// p P
{0x4e,	NUL,	'?',		NOT_USED,	NOT_USED,	'\\'},		//  ? \  */
{0x52,	NUL,	NUL,		NOT_USED,	NOT_USED,	NOT_USED},	//  
{0x54,	NUL,	NUL,		NOT_USED,	NOT_USED,	NOT_USED},	//  
{0x55,	NUL,	'`',		NOT_USED,	NOT_USED,	NOT_USED},	//  `
{0x58,	NOT_USED,NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// CAPS LOCK (wird bergeordnet behandelt)
{0x59,	NOT_USED,NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// SHIFT (wird bergeordnet behandelt)
{0x5a,	ENTER,	ENTER,		ENTER,		ENTER,		ENTER},		// ENTER
{0x5b,	'+',	'*',		NOT_USED,	NOT_USED,	'~'},		// + * ~
{0x5d,	'#',	0x27,		NOT_USED,	NOT_USED,	NOT_USED},	// # '
{0x5e,	WAKE,	WAKE,		WAKE,		WAKE,		WAKE},		// Wake
{0x61,	'<',	'>',		NOT_USED,	NOT_USED,	'|'},		// < > |
{0x66,	BS,		BS,			BS,			BS,			BS},		// Backspace
{0x69,	END,	'1',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x6b,	LEFT,	'4',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x6c,	HOME,	'7',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x70,	INS,	'0',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x71,	DEL,	',',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x72,	DOWN,	'2',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x73,	NOT_USED,'5',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x74,	RIGHT,	'6',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x75,	UP,		'8',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x76,	ESC,	ESC,		ESC,		ESC,		ESC},		// Escape
{0x77,	NOT_USED,NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// NUM LOCK (wird bergeordnet behandelt)
{0x78,	F11,	SHIFT_F11,	CTRL_F11,	ALT_F11,	ALT_F11},	// F11
{0x79,	'+',	NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block +
{0x7a,	PGDN,	'3',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x7b,	'-',	NOT_USED,	NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block -
{0x7c,	'*',	PRINT,		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block *
{0x7d,	PGUP,	'9',		NOT_USED,	NOT_USED,	NOT_USED},	// NUM-Block
{0x7e,	NOT_USED,NOT_USED,	PAUSE,		NOT_USED,	NOT_USED},	// SCROLL LOCK (wird bergeordnet behandelt)
{0x83,	F7,		SHIFT_F7,	CTRL_F7,	ALT_F7,		ALT_F7},	// F7
{0x84,	NOT_USED,NOT_USED,	NOT_USED,	PRINT,		NOT_USED}	//
};
static const unsigned char keyCount = 93; // Count of above keys.

#endif
